require 'minitest/autorun'
require 'minitest/unit'
require 'shell_quotes'

#-- |String| :: CLASS
#++

class ShellQuotesTest < Minitest::Unit::TestCase
	def test_bash_escape_file_path
		#--	NEGATIVE :: ESCAPE & UNESCAPE
		#	++
		assert_equal kraftwerk = String.new('/home/me/Music/Kraftwerk'),
			kraftwerk.bash_escape_file_path!\
				.bash_unescape_file_path!
		#-- POSITIVE :: ESCAPE & UNESCAPE
		#++
		assert_equal album =
			String.new(
"/home/me/Music/Serge Gainsbourg/Histoire de Melody Nelson/04 Ah! Melody.m4a"
			),
			album.bash_escape_file_path!\
				.bash_unescape_file_path!
		#-- RUN
		#++
		assert_equal true, system('ls ' +\
			String.new('/usr/bin/env').bash_escape_file_path!)
		#-- EXCEPTION
		#++
		assert_raises(ShellQuotes::SQError)\
			{ String.new("/home/me/Music/Miles\ Davis\u{0000}")\
				.bash_escape_file_path! }
		album = String.new("/home/me/Music/Miles Davis/Bitches' Brew/")
		assert_equal\
			String.new("/home/me/Music/Miles\\ Davis/Bitches\\'\\ Brew/"),
			cloned = album.bash_escape_file_path
		assert(album != cloned)
	end
# 	
# 	def test_bash_escape_file_path_null_character_will_raise
#			#-- !! SEE LINKED
#			#	http://stackoverflow.com/questions/15974102/error-message-test-on-minitest
#			#++
# 		exception = proc {
# 			("/home/me/Music/Miles\ Davis\u{0000}").bash_escape_file_path!
# 			}.must_raise(ShellQuotes::SQError)
# 		exception.message.must_equal(
# 			'The NULL character is disallowed inside a Unix file path.')
# 	end
#--
# 
#		#-- RUN
#		#++
# 	def test_run_bash_unescape_file_path
# 		crappyName = Dir::home + '/Crap Directory/'
# 		crappyName.bash_escape_file_path!.bash_unescape_file_path!
# 		assert_equal 0, Dir::mkdir(crappyName)
# 		Dir::rmdir(crappyName)
# 	end
#++

	def test_bash_escape_substitute
		assert_equal "$(ps -acx | grep 'iTunes' | awk '{ print $1 }')",
		String.new("ps -acx | grep 'iTunes' | awk '{ print $1 }'")\
			.bash_escape_substitute!
		assert_equal(
			"$(kill $(ps -acx | grep 'iTunes' | awk '{ print $1 }'))",
		String.new("kill `ps -acx | grep 'iTunes' | awk '{ print $1 }'`")\
			.bash_escape_substitute!)
	end

end
